﻿using System;
using System.Collections.Generic;
using System.Linq;
using Zeta.Bot.Profile;
using Zeta.Game;
using Zeta.TreeSharp;
using Zeta.XmlEngine;

namespace Trinity
{

    public class GearSwapAvoidance
    {
        public static void DisableAvoidance(AvoidanceType type)
		{
			switch(type)
			{
				case AvoidanceType.Arcane:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.Arcane);
					Trinity.Settings.Combat.AvoidanceRadius.Arcane = 2;
					break;
                case AvoidanceType.AzmodanBody:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.AzmoBodies);
                    Trinity.Settings.Combat.AvoidanceRadius.AzmoBodies = 2;
                    break;
				case AvoidanceType.AzmoFireball:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.AzmoFireBall);
					Trinity.Settings.Combat.AvoidanceRadius.AzmoFireBall = 2;
					break;
                case AvoidanceType.AzmodanPool:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.AzmoPools);
                    Trinity.Settings.Combat.AvoidanceRadius.AzmoPools = 2;
                    break;
                case AvoidanceType.BeeWasp:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.BeesWasps);
                    Trinity.Settings.Combat.AvoidanceRadius.BeesWasps = 2;
                    break;
                case AvoidanceType.Belial:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.Belial);
                    Trinity.Settings.Combat.AvoidanceRadius.Belial = 2;
                    break;
                case AvoidanceType.ButcherFloorPanel:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.ButcherFloorPanel);
                    Trinity.Settings.Combat.AvoidanceRadius.ButcherFloorPanel = 2;
                    break;
                case AvoidanceType.Desecrator:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.Desecrator);
                    Trinity.Settings.Combat.AvoidanceRadius.Desecrator = 2;
                    break;
                case AvoidanceType.DiabloMeteor:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.DiabloMeteor);
                    Trinity.Settings.Combat.AvoidanceRadius.DiabloMeteor = 2;
                    break;
                case AvoidanceType.DiabloRingOfFire:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.DiabloRingOfFire);
                    Trinity.Settings.Combat.AvoidanceRadius.DiabloRingOfFire = 2;
                    break;
                case AvoidanceType.FrozenPulse:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.FrozenPulse);
                    Trinity.Settings.Combat.AvoidanceRadius.FrozenPulse = 2;
                    break;
                case AvoidanceType.IceBall:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.IceBalls);
                    Trinity.Settings.Combat.AvoidanceRadius.IceBalls = 2;
                    break;
                case AvoidanceType.IceTrail:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.IceTrail);
                    Trinity.Settings.Combat.AvoidanceRadius.IceTrail = 2;
                    break;
                case AvoidanceType.MageFire:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.MageFire);
                    Trinity.Settings.Combat.AvoidanceRadius.MageFire = 2;
                    break;
                case AvoidanceType.MaghdaProjectille:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.MaghdaProjectille);
                    Trinity.Settings.Combat.AvoidanceRadius.MaghdaProjectille = 2;
                    break;
                case AvoidanceType.MoltenBall:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.MoltenBall);
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenBall = 2;
                    break;
                case AvoidanceType.MoltenCore:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.MoltenCore);
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenCore = 2;
                    break;
                case AvoidanceType.MoltenTrail:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.MoltenTrail);
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenTrail = 2;
                    break;
                case AvoidanceType.Orbiter:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.Orbiter);
                    Trinity.Settings.Combat.AvoidanceRadius.Orbiter = 2;
                    break;
                case AvoidanceType.PlagueCloud:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.PlagueCloud);
                    Trinity.Settings.Combat.AvoidanceRadius.PlagueCloud = 2;
                    break;
                case AvoidanceType.PlagueHand:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.PlagueHands);
                    Trinity.Settings.Combat.AvoidanceRadius.PlagueHands = 2;
                    break;
                case AvoidanceType.PoisonEnchanted:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.PoisonEnchanted);
                    Trinity.Settings.Combat.AvoidanceRadius.PoisonEnchanted = 2;
                    break;
                case AvoidanceType.PoisonTree:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.PoisonTree);
                    Trinity.Settings.Combat.AvoidanceRadius.PoisonTree = 2;
                    break;
                case AvoidanceType.ShamanFire:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.ShamanFire);
                    Trinity.Settings.Combat.AvoidanceRadius.ShamanFire = 2;
                    break;
                case AvoidanceType.Thunderstorm:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.Thunderstorm);
                    Trinity.Settings.Combat.AvoidanceRadius.Thunderstorm = 2;
                    break;
                case AvoidanceType.GhomGas:
                    GearSwapVars.RadiusesToRestore.Add(type, Trinity.Settings.Combat.AvoidanceRadius.GhomGas);
					Trinity.Settings.Combat.AvoidanceRadius.GhomGas = 2;
                    break;
			}

            DisableAvoidanceHealth(GetActorClass, type);

			Trinity.Settings.Save();
		}
		
		public static void RestoreAvoidance(AvoidanceType type)
		{
			switch(type)
			{
                case AvoidanceType.Arcane:
                    Trinity.Settings.Combat.AvoidanceRadius.Arcane = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.AzmodanBody:
                    Trinity.Settings.Combat.AvoidanceRadius.AzmoBodies = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.AzmoFireball:
                    Trinity.Settings.Combat.AvoidanceRadius.AzmoFireBall = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.AzmodanPool:
                    Trinity.Settings.Combat.AvoidanceRadius.AzmoPools = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.BeeWasp:
                    Trinity.Settings.Combat.AvoidanceRadius.BeesWasps = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.Belial:
                    Trinity.Settings.Combat.AvoidanceRadius.Belial = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.ButcherFloorPanel:
                    Trinity.Settings.Combat.AvoidanceRadius.ButcherFloorPanel = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.Desecrator:
                    Trinity.Settings.Combat.AvoidanceRadius.Desecrator = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.DiabloMeteor:
                    Trinity.Settings.Combat.AvoidanceRadius.DiabloMeteor = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.DiabloRingOfFire:
                    Trinity.Settings.Combat.AvoidanceRadius.DiabloRingOfFire = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.FrozenPulse:
                    Trinity.Settings.Combat.AvoidanceRadius.FrozenPulse = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.IceBall:
                    Trinity.Settings.Combat.AvoidanceRadius.IceBalls = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.IceTrail:
                    Trinity.Settings.Combat.AvoidanceRadius.IceTrail = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.MageFire:
                    Trinity.Settings.Combat.AvoidanceRadius.MageFire = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.MaghdaProjectille:
                    Trinity.Settings.Combat.AvoidanceRadius.MaghdaProjectille = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.MoltenBall:
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenBall = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.MoltenCore:
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenCore = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.MoltenTrail:
                    Trinity.Settings.Combat.AvoidanceRadius.MoltenTrail = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.Orbiter:
                    Trinity.Settings.Combat.AvoidanceRadius.Orbiter = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.PlagueCloud:
                    Trinity.Settings.Combat.AvoidanceRadius.PlagueCloud = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.PlagueHand:
                    Trinity.Settings.Combat.AvoidanceRadius.PlagueHands = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.PoisonEnchanted:
                    Trinity.Settings.Combat.AvoidanceRadius.PoisonEnchanted = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.PoisonTree:
                    Trinity.Settings.Combat.AvoidanceRadius.PoisonTree = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.ShamanFire:
                    Trinity.Settings.Combat.AvoidanceRadius.ShamanFire = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.Thunderstorm:
                    Trinity.Settings.Combat.AvoidanceRadius.Thunderstorm = GearSwapVars.RadiusesToRestore[type];
                    break;
                case AvoidanceType.GhomGas:
                    Trinity.Settings.Combat.AvoidanceRadius.GhomGas = GearSwapVars.RadiusesToRestore[type];
                    break;
			}

            RestoreAvoidanceHealth(GetActorClass, type);

            GearSwapVars.RadiusesToRestore.Remove(type);
			
			Trinity.Settings.Save();
		}

        public static void DisableAvoidanceHealth(string aClass, AvoidanceType type)
		{
            if (aClass == "Barbarian")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidArcaneHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidBelialHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidMageFireHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Barbarian.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.Barbarian.AvoidGhomGasHealth = 0;
                        break;
                }
            }
            else if (aClass == "Crusader")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidArcaneHealth);
                        Trinity.Settings.Combat.Crusader.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.Crusader.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.Crusader.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.Crusader.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.Crusader.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidBelialHealth);
                        Trinity.Settings.Combat.Crusader.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.Crusader.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.Crusader.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.Crusader.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.Crusader.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.Crusader.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.Crusader.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.Crusader.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidMageFireHealth);
                        Trinity.Settings.Combat.Crusader.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.Crusader.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.Crusader.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.Crusader.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.Crusader.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.Crusader.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.Crusader.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.Crusader.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.Crusader.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.Crusader.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.Crusader.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.Crusader.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Crusader.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.Crusader.AvoidGhomGasHealth = 0;
                        break;
                }
            }
            else if (aClass == "DemonHunter")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidArcaneHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidBelialHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidMageFireHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.DemonHunter.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.DemonHunter.AvoidGhomGasHealth = 0;
                        break;
                }
            }
            else if (aClass == "Monk")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidArcaneHealth);
                        Trinity.Settings.Combat.Monk.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.Monk.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.Monk.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.Monk.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.Monk.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidBelialHealth);
                        Trinity.Settings.Combat.Monk.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.Monk.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.Monk.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.Monk.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.Monk.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.Monk.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.Monk.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.Monk.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidMageFireHealth);
                        Trinity.Settings.Combat.Monk.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.Monk.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.Monk.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.Monk.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.Monk.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.Monk.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.Monk.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.Monk.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.Monk.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.Monk.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.Monk.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.Monk.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Monk.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.Monk.AvoidGhomGasHealth = 0;
                        break;
                }
            }
            else if (aClass == "Witchdoctor")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidArcaneHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidBelialHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidMageFireHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.WitchDoctor.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.WitchDoctor.AvoidGhomGasHealth = 0;
                        break;
                }
            }
            else if (aClass == "Wizard")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidArcaneHealth);
                        Trinity.Settings.Combat.Wizard.AvoidArcaneHealth = 0;
                        break;
                    case AvoidanceType.AzmodanBody:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidAzmoBodiesHealth);
                        Trinity.Settings.Combat.Wizard.AvoidAzmoBodiesHealth = 0;
                        break;
                    case AvoidanceType.AzmoFireball:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidAzmoFireBallHealth);
                        Trinity.Settings.Combat.Wizard.AvoidAzmoFireBallHealth = 0;
                        break;
                    case AvoidanceType.AzmodanPool:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidAzmoPoolsHealth);
                        Trinity.Settings.Combat.Wizard.AvoidAzmoPoolsHealth = 0;
                        break;
                    case AvoidanceType.BeeWasp:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidBeesWaspsHealth);
                        Trinity.Settings.Combat.Wizard.AvoidBeesWaspsHealth = 0;
                        break;
                    case AvoidanceType.Belial:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidBelialHealth);
                        Trinity.Settings.Combat.Wizard.AvoidBelialHealth = 0;
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidButcherFloorPanelHealth);
                        Trinity.Settings.Combat.Wizard.AvoidButcherFloorPanelHealth = 0;
                        break;
                    case AvoidanceType.Desecrator:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidDesecratorHealth);
                        Trinity.Settings.Combat.Wizard.AvoidDesecratorHealth = 0;
                        break;
                    case AvoidanceType.DiabloMeteor:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidDiabloMeteorHealth);
                        Trinity.Settings.Combat.Wizard.AvoidDiabloMeteorHealth = 0;
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidDiabloRingOfFireHealth);
                        Trinity.Settings.Combat.Wizard.AvoidDiabloRingOfFireHealth = 0;
                        break;
                    case AvoidanceType.FrozenPulse:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidFrozenPulseHealth);
                        Trinity.Settings.Combat.Wizard.AvoidFrozenPulseHealth = 0;
                        break;
                    case AvoidanceType.IceBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidIceBallsHealth);
                        Trinity.Settings.Combat.Wizard.AvoidIceBallsHealth = 0;
                        break;
                    case AvoidanceType.IceTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidIceTrailHealth);
                        Trinity.Settings.Combat.Wizard.AvoidIceTrailHealth = 0;
                        break;
                    case AvoidanceType.MageFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidMageFireHealth);
                        Trinity.Settings.Combat.Wizard.AvoidMageFireHealth = 0;
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidMaghdaProjectilleHealth);
                        Trinity.Settings.Combat.Wizard.AvoidMaghdaProjectilleHealth = 0;
                        break;
                    case AvoidanceType.MoltenBall:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidMoltenBallHealth);
                        Trinity.Settings.Combat.Wizard.AvoidMoltenBallHealth = 0;
                        break;
                    case AvoidanceType.MoltenCore:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidMoltenCoreHealth);
                        Trinity.Settings.Combat.Wizard.AvoidMoltenCoreHealth = 0;
                        break;
                    case AvoidanceType.MoltenTrail:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidMoltenTrailHealth);
                        Trinity.Settings.Combat.Wizard.AvoidMoltenTrailHealth = 0;
                        break;
                    case AvoidanceType.Orbiter:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidOrbiterHealth);
                        Trinity.Settings.Combat.Wizard.AvoidOrbiterHealth = 0;
                        break;
                    case AvoidanceType.PlagueCloud:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidPlagueCloudHealth);
                        Trinity.Settings.Combat.Wizard.AvoidPlagueCloudHealth = 0;
                        break;
                    case AvoidanceType.PlagueHand:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidPlagueHandsHealth);
                        Trinity.Settings.Combat.Wizard.AvoidPlagueHandsHealth = 0;
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidPoisonEnchantedHealth);
                        Trinity.Settings.Combat.Wizard.AvoidPoisonEnchantedHealth = 0;
                        break;
                    case AvoidanceType.PoisonTree:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidPoisonTreeHealth);
                        Trinity.Settings.Combat.Wizard.AvoidPoisonTreeHealth = 0;
                        break;
                    case AvoidanceType.ShamanFire:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidShamanFireHealth);
                        Trinity.Settings.Combat.Wizard.AvoidShamanFireHealth = 0;
                        break;
                    case AvoidanceType.Thunderstorm:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidThunderstormHealth);
                        Trinity.Settings.Combat.Wizard.AvoidThunderstormHealth = 0;
                        break;
                    case AvoidanceType.GhomGas:
                        GearSwapVars.HealthToRestore.Add(type, Trinity.Settings.Combat.Wizard.AvoidGhomGasHealth);
                        Trinity.Settings.Combat.Wizard.AvoidGhomGasHealth = 0;
                        break;
                }
            }
		}
		
		public static void RestoreAvoidanceHealth(string aClass, AvoidanceType type)
		{
            if (aClass == "Barbarian")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.Barbarian.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.Barbarian.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.Barbarian.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.Barbarian.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.Barbarian.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.Barbarian.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.Barbarian.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.Barbarian.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.Barbarian.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.Barbarian.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.Barbarian.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.Barbarian.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.Barbarian.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.Barbarian.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.Barbarian.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.Barbarian.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.Barbarian.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.Barbarian.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.Barbarian.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.Barbarian.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.Barbarian.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.Barbarian.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }
            else if (aClass == "Crusader")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.Crusader.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.Crusader.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.Crusader.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.Crusader.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.Crusader.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.Crusader.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.Crusader.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.Crusader.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.Crusader.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.Crusader.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.Crusader.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.Crusader.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.Crusader.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.Crusader.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.Crusader.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.Crusader.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.Crusader.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.Crusader.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.Crusader.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.Crusader.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.Crusader.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.Crusader.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.Crusader.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.Crusader.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.Crusader.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.Crusader.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }
            else if (aClass == "DemonHunter")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.DemonHunter.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.DemonHunter.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.DemonHunter.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.DemonHunter.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.DemonHunter.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.DemonHunter.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.DemonHunter.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.DemonHunter.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.DemonHunter.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.DemonHunter.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.DemonHunter.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.DemonHunter.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.DemonHunter.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.DemonHunter.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.DemonHunter.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.DemonHunter.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.DemonHunter.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.DemonHunter.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.DemonHunter.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.DemonHunter.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.DemonHunter.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.DemonHunter.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }
            else if (aClass == "Monk")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.Monk.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.Monk.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.Monk.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.Monk.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.Monk.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.Monk.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.Monk.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.Monk.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.Monk.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.Monk.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.Monk.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.Monk.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.Monk.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.Monk.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.Monk.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.Monk.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.Monk.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.Monk.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.Monk.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.Monk.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.Monk.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.Monk.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.Monk.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.Monk.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.Monk.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.Monk.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }
            else if (aClass == "Witchdoctor")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.WitchDoctor.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.WitchDoctor.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.WitchDoctor.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.WitchDoctor.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.WitchDoctor.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.WitchDoctor.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.WitchDoctor.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.WitchDoctor.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.WitchDoctor.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.WitchDoctor.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.WitchDoctor.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.WitchDoctor.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.WitchDoctor.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.WitchDoctor.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.WitchDoctor.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.WitchDoctor.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.WitchDoctor.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.WitchDoctor.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.WitchDoctor.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.WitchDoctor.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.WitchDoctor.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.WitchDoctor.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }
            else if (aClass == "Wizard")
            {
                switch (type)
                {
                    case AvoidanceType.Arcane:
                        Trinity.Settings.Combat.Wizard.AvoidArcaneHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanBody:
                        Trinity.Settings.Combat.Wizard.AvoidAzmoBodiesHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmoFireball:
                        Trinity.Settings.Combat.Wizard.AvoidAzmoFireBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.AzmodanPool:
                        Trinity.Settings.Combat.Wizard.AvoidAzmoPoolsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.BeeWasp:
                        Trinity.Settings.Combat.Wizard.AvoidBeesWaspsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Belial:
                        Trinity.Settings.Combat.Wizard.AvoidBelialHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ButcherFloorPanel:
                        Trinity.Settings.Combat.Wizard.AvoidButcherFloorPanelHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Desecrator:
                        Trinity.Settings.Combat.Wizard.AvoidDesecratorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloMeteor:
                        Trinity.Settings.Combat.Wizard.AvoidDiabloMeteorHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.DiabloRingOfFire:
                        Trinity.Settings.Combat.Wizard.AvoidDiabloRingOfFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.FrozenPulse:
                        Trinity.Settings.Combat.Wizard.AvoidFrozenPulseHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceBall:
                        Trinity.Settings.Combat.Wizard.AvoidIceBallsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.IceTrail:
                        Trinity.Settings.Combat.Wizard.AvoidIceTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MageFire:
                        Trinity.Settings.Combat.Wizard.AvoidMageFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MaghdaProjectille:
                        Trinity.Settings.Combat.Wizard.AvoidMaghdaProjectilleHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenBall:
                        Trinity.Settings.Combat.Wizard.AvoidMoltenBallHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenCore:
                        Trinity.Settings.Combat.Wizard.AvoidMoltenCoreHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.MoltenTrail:
                        Trinity.Settings.Combat.Wizard.AvoidMoltenTrailHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Orbiter:
                        Trinity.Settings.Combat.Wizard.AvoidOrbiterHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueCloud:
                        Trinity.Settings.Combat.Wizard.AvoidPlagueCloudHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PlagueHand:
                        Trinity.Settings.Combat.Wizard.AvoidPlagueHandsHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonEnchanted:
                        Trinity.Settings.Combat.Wizard.AvoidPoisonEnchantedHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.PoisonTree:
                        Trinity.Settings.Combat.Wizard.AvoidPoisonTreeHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.ShamanFire:
                        Trinity.Settings.Combat.Wizard.AvoidShamanFireHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.Thunderstorm:
                        Trinity.Settings.Combat.Wizard.AvoidThunderstormHealth = GearSwapVars.HealthToRestore[type];
                        break;
                    case AvoidanceType.GhomGas:
                        Trinity.Settings.Combat.Wizard.AvoidGhomGasHealth = GearSwapVars.HealthToRestore[type];
                        break;
                }
            }

            GearSwapVars.HealthToRestore.Remove(type);
		}

        #region Misc Helpers

        public static bool IsAvoidanceDisabled(AvoidanceType type)
        {
            return GearSwapVars.RadiusesToRestore.Any(r => r.Key == type) && GearSwapVars.HealthToRestore.Any(h => h.Key == type);
        }

        public static string GetActorClass
        {
            get { return ZetaDia.Me.ActorClass.ToString(); }
        }

        #endregion
    }
}  