﻿using System;
using System.Collections.Generic;
using Zeta.Bot.Profile;
using Zeta.TreeSharp;
using Zeta.XmlEngine;

namespace Trinity
{
    public class GearSwapObjects
    {				
		public static void ChangeContainersState(bool OACState, bool ICState, bool GCState, bool WRState, bool OCState, bool ORCState)
		{
			OpenAnyContainers(OACState);
			InspectCorpses(ICState);
			GroundContainers(GCState);
			WeaponRacks(WRState);
			OpenChests(OCState);
			OpenRareChest(ORCState);
			SaveSettings();
		}
		
		public static void RestoreContainersState()
		{
			foreach(KeyValuePair<string, bool> kvp in GearSwapVars.ContainersStatesToRestore)
			{
				switch(kvp.Key)
				{
					case "OpenAnyContainers":
						OpenAnyContainers(kvp.Value);
						break;
					case "InspectCorpses":
						InspectCorpses(kvp.Value);
						break;
					case "GroundContainers":
						GroundContainers(kvp.Value);
						break;
					case "WeaponRacks":
						WeaponRacks(kvp.Value);
						break;
					case "OpenChests":
						OpenChests(kvp.Value);
						break;
					case "OpenRareChest":
						OpenRareChest(kvp.Value);
						break;
				}
			}
			
			ClearDic();
		}
		
		public static void OpenAnyContainers(bool state)
		{
			AddKeyToDic("OpenAnyContainers", Trinity.Settings.WorldObject.OpenAnyContainer);
			Trinity.Settings.WorldObject.OpenAnyContainer = state;
		}
		
		public static void InspectCorpses(bool state)
		{
			AddKeyToDic("InspectCorpses", Trinity.Settings.WorldObject.InspectCorpses);
			Trinity.Settings.WorldObject.InspectCorpses = state;
		}
		
		public static void GroundContainers(bool state)
		{
			AddKeyToDic("GroundContainers", Trinity.Settings.WorldObject.InspectGroundClicky);
			Trinity.Settings.WorldObject.InspectGroundClicky = state;
		}
		
		public static void WeaponRacks(bool state)
		{
			AddKeyToDic("WeaponRacks", Trinity.Settings.WorldObject.InspectWeaponRacks);
			Trinity.Settings.WorldObject.InspectWeaponRacks = state;
		}
		
		public static void OpenChests(bool state)
		{
			AddKeyToDic("OpenChests", Trinity.Settings.WorldObject.OpenContainers);
			Trinity.Settings.WorldObject.OpenContainers = state;
		}
		
		public static void OpenRareChest(bool state)
		{
			AddKeyToDic("OpenRareChest", Trinity.Settings.WorldObject.OpenRareChests);
			Trinity.Settings.WorldObject.OpenRareChests = state;
		}
		
		public static void SaveSettings()
		{
			Trinity.Settings.Save();
		}
		
		public static void AddKeyToDic(string key, bool value)
		{
			if (GearSwapVars.ContainersStatesToRestore.ContainsKey(key)) return;
			GearSwapVars.ContainersStatesToRestore.Add(key, value);
		}
		
		public static void ClearDic()
		{
			GearSwapVars.ContainersStatesToRestore.Clear();
		}
    }
}  